local iLvl = {
  Name = "Easy iLvl",
  Version = "v1.6.0",
  Author = "R�ncid@Firetree",
  frame = CreateFrame("Frame"),
  set = 0
}

local Items = {
  CharacterHeadSlot = 1,
  CharacterNeckSlot = 2,
  CharacterShoulderSlot = 3,
  CharacterBackSlot = 15,
  CharacterChestSlot = 5,
  CharacterWristSlot = 9,
  CharacterHandsSlot = 10,
  CharacterWaistSlot = 6,
  CharacterLegsSlot = 7,
  CharacterFeetSlot = 8,
  CharacterFinger0Slot = 11,
  CharacterFinger1Slot = 12,
  CharacterTrinket0Slot = 13,
  CharacterTrinket1Slot = 14,
  CharacterMainHandSlot = 16,
  CharacterSecondaryHandSlot = 17,
  CharacterRangedSlot = 18,
  CharacterAmmoSlot = 0
}

function iLvl_Update()
  for Key, Value in pairs(Items) do

    local itemLink = GetInventoryItemLink("player", Value)
    local slot = getglobal(Key.."Stock");

    if slot then
      slot:Hide();
      if itemLink then
        local _, _, _, _, itemRarity = GetItemInfo(itemLink)
        local itemLevel, r, g, b = iLvl_Extract_Item_Level(itemLink)

        slot:SetText(itemLevel);
        slot:SetTextColor(r, g, b, 1);
        slot:Show();
      end
    end
  end
end

-- Create the tooltip:
local scantip = CreateFrame("GameTooltip", "iLvl_Tooltip", nil, "GameTooltipTemplate")
scantip:SetOwner(UIParent, "ANCHOR_NONE")

function iLvl_Extract_Item_Level(itemLink)
  scantip:SetHyperlink(itemLink)

  -- get the text color
  local r,g,b =  _G["iLvl_TooltipTextLeft"..1]:GetTextColor()

  -- Scan the tooltip:
  for i = 2, scantip:NumLines() do -- Line 1 is always the name so you can skip it.
    local text = _G["iLvl_TooltipTextLeft"..i]:GetText()
    if text and text ~= "" then
      local num = tonumber(string.sub(text,-1))
      if num then
        return string.match(text,'%d+'), r, g, b
      end
    end
  end
end

iLvl.frame:SetScript("OnEvent", function(self, event, ...)
  if event == "PLAYER_ENTERING_WORLD" and iLvl.set == 0 then
    iLvl.set = 1;
    iLvl.frame:RegisterEvent("UNIT_PORTRAIT_UPDATE");
    iLvl.frame:RegisterEvent("ITEM_UPGRADE_MASTER_UPDATE");
  end
  
  if event == "UNIT_PORTRAIT_UPDATE" then
    iLvl_Update();
  end
end)

iLvl.frame:RegisterEvent("PLAYER_ENTERING_WORLD");